/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|   
|   Foundation, Inc., 
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|  
|
|                   querygen.h REV 4 for SQL Query Generator
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|  
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/
#ifndef QUERYGEN_H
#define QUERYGEN_H

#define MAX 255
#define BIGBUF 1000

#define PROGRAM_VERSION 0.8




#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


char out[MAX];     //this is the output filename variable
char ctqfile[MAX]; //the location of the CREATE TABLE QUERY file is stored here
int appendfile;       //option for appending file
int printstdout;     //option for printing output to stdout
int useoutputfile;       //set to 0 if user is using --print-stdout and doesn't want to use an output file, otherwise set it to 1
char *p_addslash;  //will point to output_buffer from addslash()





/*=======================================================================
|  This struct contains the following variables
|   name[100]              the name of the column
|   type[8]                   the type of column(CHAR, INTEGER, etc)
|   int null                   this will be 1 if the column is NOT NULL and 0 if it can contain a NULL value
========================================================================*/

      typedef struct{
            char name[100];
            char type[8];
            int null;        
          }sqltable;



extern void insert_query( void );
extern void update_query( void );
extern void delete_query( void );
extern char *skipcomment( FILE *fp );
extern sqltable *getcolumn( FILE *fp );
extern char *gettable( FILE *fp );
extern int chkres( char *wordtocheck );
extern char *addslash( char *string);




#endif
