 /*============================================================================ 
|   Copyright (C) 2003  Jonathan Harm                                           
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   addslash.c INITIAL for SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/ 

#include <querygen.h>

char *addslash(char *string)
{

      char input_buffer[BIGBUF];    //the string that was passed to this function
      static char output_buffer[BIGBUF];   //the buffer that will contain the value that is returned
     // static char *p_output_buffer = output_buffer;
      int i;  //counter
      int shift_tally = 0; //how far output_buffer gets shifted to the right


      //copy the string to the buffer
      strcpy(input_buffer, string);


      //examine each character to determine
      //if a slash should be added
      for(i = 0; i < BIGBUF; i++)
      {
             
            if(input_buffer[i] == '\'')
            {              
               shift_tally++; //found a single quote, so the rest of the buffer is
                                  //gonna have to get shifted to the right
               output_buffer[i+shift_tally-1] = '\\';   //do this because output_buffer[i] wont always be the right spot
               output_buffer[i+shift_tally] = '\'';
             }

             if(input_buffer[i] == '\\')
             {
                shift_tally++; //same as above, excecpt this handles backslashes
                output_buffer[i+shift_tally-1] = '\\';  //do this because output_buffer[i] wont always be the right spot
                output_buffer[i+shift_tally] = '\\';

              }
                


            else if(input_buffer[i] == '\0')
            {  output_buffer[i+shift_tally] = '\0';
              break; }
       

            else
            {  //if it wasn't a ' or " then just throw it in the output_buffer
              output_buffer[i+shift_tally] = input_buffer[i];
            }

        
         }   


   return output_buffer;

}


/*============================================================================
|   Copyright (C) 2002  Jonathan Harm
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   chkres.c for SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/
#include "querygen.h"

//this function will check to see if *wordtocheck is a sql reserved word
//if it is the function will return 1, else 0 is returned

int chkres( char *wordtocheck )
{


       char reserved_word[326][15] = {   {"absolute"}, {"action"}, {"add"}, {"after"}, {"all"}, {"allocate"},
                                                         {"alter"}, {"and"}, {"any"}, {"are"}, {"as"}, {"asc"}, {"ascending"},
                                                         {"assertion"}, {"at"}, {"authorization"}, {"auto"}, {"autoinc"},
                                                         {"avg"}, {"backup"}, {"before"}, {"before"}, {"begin"}, {"between"},
                                                         {"bit"}, {"blob"}, {"boolean"}, {"both"}, {"break"}, {"browse"},
                                                         {"bulk"}, {"by"}, {"bytes"}, {"cache"}, {"cascade"}, {"case"}, {"cast"},
                                                         {"catalog"}, {"char"}, {"character"}, {"check"}, {"checkpoint"},
                                                         {"close"}, {"clustered"}, {"coalesce"}, {"collate"}, {"column"},
                                                         {"comment"}, {"commit"}, {"committed"}, {"compute"}, {"computed"},
                                                         {"conditional"}, {"confirm"}, {"connect"}, {"connection"},
                                                         {"constraint"}, {"constraints"}, {"containing"}, {"contains"},
                                                         {"containstable"},  {"continue"}, {"controlrow"}, {"convert"}, {"count"},
                                                         {"create"}, {"cross"}, {"cstring"}, {"cube"}, {"current"}, {"cursor"},
                                                         {"database"}, {"date"}, {"datetime"}, {"day"}, {"dbcc"}, {"deallocate"},
                                                         {"debug"}, {"dec"}, {"decimal"}, {"declare"}, {"default"}, {"delete"},
                                                         {"deny"}, {"desc"}, {"descending"}, {"describe"}, {"disconnect"}, {"disk"},
                                                         {"distinct"}, {"distributed"}, {"do"}, {"domain"}, {"double"}, {"drop"},
                                                         {"dummy"}, {"dump"}, {"else"}, {"end"}, {"errlvl"}, {"errorexit"}, {"escape"},
                                                         {"except"}, {"exception"}, {"exec"}, {"execute"}, {"exists"}, {"exit"},
                                                         {"external"}, {"extract"}, {"false"}, {"fetch"}, {"file"}, {"fillfactor"}, {"filter"},
                                                         {"float"}, {"floppy"}, {"for"}, {"foreign"}, {"found"}, {"freetext"},
                                                         {"freetexttable"}, {"from"}, {"full"}, {"function"}, {"generator"}, {"get"},
                                                         {"go"}, {"goto"}, {"grant"}, {"group"}, {"having"}, {"holdlock"}, {"hour"},
                                                         {"identity"}, {"if"}, {"in"}, {"inacive"}, {"index"}, {"indicator"}, {"inner"},
                                                         {"input"}, {"insert"}, {"int"}, {"integer"}, {"intersect"}, {"interval"}, {"into"},
                                                         {"is"}, {"isolation"}, {"join"}, {"key"}, {"kill"}, {"language"}, {"last"}, {"leading"},
                                                         {"left"}, {"length"}, {"level"}, {"like"}, {"lineno"}, {"load"}, {"local"}, {"logfile"},
                                                         {"long"}, {"lower"}, {"manual"}, {"match"}, {"max"}, {"merge"}, {"message"},
                                                         {"min"}, {"minute"}, {"mirrorexit"}, {"module"}, {"money"}, {"month"},
                                                         {"names"}, {"national"}, {"nchar"}, {"next"}, {"no"}, {"nocheck"},
                                                         {"nonclustered"}, {"none"}, {"not"}, {"null"}, {"nullif"}, {"numeric"}, {"of"},
                                                         {"off"}, {"offsets"}, {"on"}, {"once"}, {"only"}, {"open"}, {"option"}, {"or"},
                                                         {"order"}, {"outer"}, {"output"}, {"over"}, {"overflow"}, {"pad"}, {"page"},
                                                         {"pages"}, {"parameter"}, {"partial"}, {"password"}, {"percent"}, {"perm"},
                                                         {"permanent"}, {"pipe"}, {"plan"}, {"position"}, {"precision"}, {"prepare"},
                                                         {"primary"}, {"print"}, {"prior"}, {"privileges"}, {"proc"}, {"procedure"},
                                                         {"processexit"}, {"protected"}, {"public"}, {"raiserror"}, {"read"}, {"readtext"},
                                                         {"real"}, {"references"}, {"relative"}, {"replication"}, {"reserv"}, {"reserving"},
                                                         {"restore"}, {"restrict"}, {"retain"}, {"return"}, {"returns"}, {"revoke"}, {"right"},
                                                         {"rollback"}, {"rollup"}, {"rowcount"}, {"rule"}, {"save"}, {"schema"},
                                                         {"second"}, {"section"}, {"segment"}, {"select"}, {"sequence"}, {"set"},
                                                         {"setuser"}, {"shadow"}, {"shared"}, {"shutdown"}, {"singular"}, {"size"},
                                                         {"smallint"}, {"snapshot"}, {"some"}, {"sort"}, {"space"}, {"sql"}, {"sqlcode"},
                                                         {"sqlerror"}, {"stability"}, {"starting"}, {"stsrts"}, {"statistics"}, {"substring"},
                                                         {"sum"}, {"suspend"}, {"table"}, {"tape"}, {"temp"}, {"temporary"}, {"text"},
                                                         {"textsize"}, {"then"}, {"time"}, {"timestamp"}, {"to"}, {"top"}, {"trailing"},
                                                         {"tran"}, {"transaction"}, {"translate"}, {"trigger"}, {"trim"}, {"true"},
                                                         {"truncate"}, {"uncommitted"}, {"union"}, {"unique"}, {"update"},
                                                         {"updatetext"}, {"upper"}, {"usage"}, {"use"}, {"user"}, {"using"}, {"value"},
                                                         {"values"}, {"varchar"}, {"variable"}, {"varying"}, {"view"}, {"volume"},
                                                         {"wait"}, {"waitfor"}, {"when"}, {"where"}, {"while"}, {"with"}, {"work"},
                                                         {"write"}, {"writetext"}, {"year"}, {"zone"} };




        char wordtocheck_array[15]; //use array to change wordtocheck to lower case
        int i; //for counting in the loop


       //change to lower case
       strcpy(wordtocheck_array, wordtocheck);

       for(i = 0; i < 15; i++)
       {
           wordtocheck_array[i] = tolower(wordtocheck_array[i]);
       }



      for(i  = 0; i < 326; i++)
       {

            if( strcmp(reserved_word[i], wordtocheck_array) ==  0)
             return 1;

        }


        return 0;


}



/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   delete_query.c REV 3 for SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/ 


#include "querygen.h"


void delete_query( void )
{

  extern char out[MAX];
  extern char ctqfile[MAX];	                       // this is the CREATE TABLE query file
  char delete_query[BIGBUF];                  //this is what is written to the file
  char unique_column[MAX];                    //the column that contains info unique to the row being deleted
  char unique_query[MAX];                      //portion of the query that contains the WHERE clause
  char unique_info[MAX];                         //the unique info (i.e. WHERE delete_unique_column = unique_info)
  char *p_unique_info = unique_info;
  extern char *p_addslash;                       //defined in querygen.h
  char table_or_row;	                               //ask user if they want to delete the table or row
  char *tablename, *p_ctqbuf;
  int loop_done, user_done;                     //used to control loops
  extern int appendfile;
  extern int printstdout;
  extern int useoutputfile;
  sqltable *column;                                  //used for finding the datatype of a column

   // used for converting a string to a numerical
 //datatype when creating the unique_query string
  char        input_tinyint;
  int           input_smallint;
  long        input_integer;
  float        input_floatingpoint;

   FILE *fpctq, *fpout;



  //First open "ctq" in read only mode and open "out" for writing

  if( (fpctq = fopen(ctqfile, "r")) == NULL) {
    fprintf(stderr, "\nCouldn't open file %s\n", ctqfile);
    exit(1);
    }


if(useoutputfile == 1)
{

  if(appendfile == 1)
  {

      if( (fpout = fopen(out, "a")) == NULL)
      {
         fprintf(stderr, "\nCouldn't create file %s\n", out);
         exit(2);
        }

  }


  else
  {

        if( (fpout = fopen(out, "w")) == NULL)
        {
            fprintf(stderr, "\nCouldn't create file %s\n", out);
            exit(2);
         }

    fprintf(fpout, "/* This file made by SQL Query Generator %.1f*/\n", PROGRAM_VERSION);
    fprintf(fpout, "/* go to http://change.to/opensource for the latest updates */\n\n\n");
  }

} //end of "if(useoutputfile ==1)"




  while( loop_done != 1)
  {

    //make unique_quey[0] NULL and check to see if it is still null after the while
   //loop that checks the data types, if it is still NULL, then the user entered a
   //column name for unique_column that doesn't exist
   unique_query[0] = '\0';


     rewind(fpctq); //rewind so gettable() wont return 0 when the loop restarts
     if( (tablename = gettable(fpctq)) == 0)
     exit(1);



       //ask user if they want to delete the whole table or only certain rows
       printf("\nDo you want to delete the whole [T]able or only certain [R]ow(s)? ");
       table_or_row = toupper(getc(stdin));
       getc(stdin); //eat newline


       if( table_or_row == 'T' )
       {

           //we already have the table name, now make the query
           sprintf(delete_query, "DELETE FROM %s;\n\n", tablename);

           if(printstdout == 1) {
            printf("\nHere is your query:\n\n\n");
            printf("%s", delete_query);
            }
           
          //write query to output file
         else fprintf(fpout, "%s", delete_query);

       }




       //First get tablename, then ask user what column has unique
       //info about the row(s) that they want to delete.  Then ask for
       //the unique info.  Don't forget to check for the datatype before
       //writing the unique info to the query.

       if( table_or_row == 'R' )
       {

           //start out by making the first part of the query
           sprintf(delete_query, "DELETE FROM %s", tablename);


           printf("\nWhat column contains unique information about the row(s) that you want to delete? ");
           fgets(unique_column, MAX, stdin); unique_column[strlen(unique_column)-1] = '\0';



            //ask user to type in the information unique to the row(s) they want to delete
            printf("\nNow type in the information that is unique in that column: ");
            fgets(unique_info, MAX, stdin);   unique_info[strlen(unique_info)-1] = '\0';

            p_addslash = addslash(p_unique_info);
            strcpy(p_unique_info, p_addslash);


              rewind(fpctq);
              //first get to the part of the fpctq file that creates
              //the columns for the table that the user wants
             //to make a query for

             while ( (p_ctqbuf = skipcomment(fpctq)) != NULL )
             {
                 if(strcmp(p_ctqbuf, tablename) == 0)
                 break;
               
             }
     

            //get datatype of column so the program will
            //know if it needs to put qoutes around the input
            while( (column = getcolumn(fpctq)) != 0)
            {

                 //as soon as the column name is found check to see if it is numerical or string
                 //datatype so the program can put quotes around numerical data and leave
                 //qoutes off of strings
                 if( strcmp(column->name, unique_column) == 0)
                 {
                   //first take care of numerical datatypes
                     
                     if( strcmp(column->type,"SMALLINT") == 0)
                      {
                        input_smallint = atoi(unique_info);
                        sprintf(unique_query, "WHERE %s = %d", unique_column, input_smallint);
                      }


                     else if( strcmp(column->type,"TINYINT") == 0)
                      {
                        input_tinyint = atoi(unique_info);
                        sprintf(unique_query,"WHERE %s = %d", unique_column, input_tinyint);
                      }


                     else if( strcmp(column->type,"FLOAT") == 0)
                      {
                        input_floatingpoint = atoi(unique_info);
                        sprintf(unique_query,"WHERE %s = %f", unique_column, input_floatingpoint);
                      }


                     else if( strcmp(column->type,"INTEGER") == 0 || strcmp(column->type,"REAL") == 0)
                      {
                        input_integer = atoi(unique_info);
                        sprintf(unique_query,"WHERE %s = %ld", unique_column, input_integer);
                      }


          /*
         //               Done with the numerical data.  Everything below this line
         //               will only deal with character type data.
         //=====================================================*/


                      else if( strcmp(column->type,"CHAR") == 0)
                       {
                         sprintf(unique_query,"WHERE %s = \'%s\'", unique_column, unique_info);
                       }



                    // if the datatype of the column the user entered data for
                    // was not in the above if statement, then that datatype is
                    // not supported
                    else
                     {
                       fprintf(stderr, "Datatype %s not supported\n", column->type);
                     }


                 }

                 
     } //end of while loop

      //for info on the line below, see first comment in the while(loop_done != 1) loop
      if(unique_query[0] == '\0') {fprintf(stderr, "\nError: Invalid column name.\n"); exit(1); }


           if(printstdout == 1)  {
            printf("\nHere is your query:\n\n\n");
            printf( "%s\n%s;\n\n", delete_query, unique_query);
            }

           else
            fprintf(fpout, "%s\n%s;\n\n", delete_query, unique_query);

        }



        printf("\nAre you done making delete queries?(N/y)");

         user_done = toupper(getc(stdin));

         switch (user_done) {

                 case 'Y' :

                     printf("\nThank you for using SQL Query Generator %.1f.\n", PROGRAM_VERSION);

                      //close files before exiting
                      if(useoutputfile == 1) fclose(fpout);
                      fclose(fpctq);
                      loop_done = 1;

                      break;


                 case 'N' :
                       loop_done = 0;
                       memset(delete_query, ' ', BIGBUF);
                       memset(unique_info, ' ', BIGBUF);
                       getc(stdin); //eat newline

                       break;


                 default :
                        loop_done = 0;
                        memset(delete_query, ' ', BIGBUF);
                        memset(unique_info, ' ', BIGBUF);

                         break;

                } //end of switch


  } //end of while(loop_done != 1)

exit(0);

}
/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm                                          
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|   
|   Foundation, Inc., 
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|  
|
|                   getcolumn.c REV 3 for SQL Query Generator
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|  
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/
#include "querygen.h"


sqltable *getcolumn( FILE *fp )
{



       static sqltable column, *p_column;      //one is the struct and the other is the pointer that is returned
       int i;                                                // i is for counting in loops
       char *p_ctqbuf;                                //this holds the string that skipcomment gets
       char ctqbuf[MAX];                            //use this to copy p_ctqbuf into for things that we need an array for
       char ucase[MAX];                            //upper case buffer(easier to use for checking for types)



        //set these to 1 when their corresponding struct member gets a value
        int name_done = 0, type_done = 0, null_done = 0;



        //initialize pointer to column
        p_column = &column;


    //clear the structure before continuing
    memset(&column, 0, sizeof(column));




                                       


while ( (p_ctqbuf = skipcomment(fp)) != NULL ) {

           

               
  
  //some stuff(like the for loop below) needs an array not a pointer
  strcpy(ctqbuf, p_ctqbuf);
  strcpy(ucase, p_ctqbuf);

  //make the ucase buffer upper case
  for(i = 0; i < MAX; i++) {

        ucase[i] = toupper(ucase[i]);

  }


  /* look for the word "CREATE".
  if it is found, then return 0 because
  that means we are done w/ the previous table

  if this is the last table in the CREATE TABLE query
  file, the word CREATE wont be found, but skipcomment()
  will return NULL causing the loop here to end returning 0
  */
  if(strstr(ucase, "CREATE"))
  return 0;


/*===========================CHAR==NCHAR==NVARCHAR==========================*/

    if( strstr(ucase, "CHAR") ) {

         sprintf(column.type, "CHAR");
         type_done = 1;


    }

/*===================================BIT================================*/



    if( strstr(ucase, "BIT")) {

          sprintf(column.type, "BIT");
          type_done = 1;

    }



 /*===================================DECIMAL===============================*/



    if( strstr(ucase, "DECIMAL")) {

          sprintf(column.type, "DECIMAL");
          type_done = 1;

    }



/*===================================SMALLINT=================================*/

    if( strstr(ucase, "SMALLINT") ) {

         sprintf(column.type, "SMALLINT");
         type_done = 1;


    }


/*===================================TINYINT=================================*/

    if( strstr(ucase, "TINYINT") ) {

         sprintf(column.type, "TINYINT");
         type_done = 1;


    }



/*===================================INT==INTEGER==========================*/



    if( strstr(ucase, "INT") ) {

          sprintf(column.type, "INTEGER");
          type_done = 1;

    }



/*=================================== FLOAT ================================*/

    if( strstr(ucase, "FLOAT")) {

          sprintf(column.type, "FLOAT");
          type_done = 1;

    }


/*===================================VARCHAR================================*/


     if( strstr(ucase, "VARCHAR") ) {

           sprintf(column.type, "VARCHAR");
           type_done = 1;

     }


/*===================================NOT NULL================================*/




    
    //if the name and type have been found, look for the end of the line or end of the CREATE TABLE query
    if( (name_done == 1 && type_done == 1) && (strchr(p_ctqbuf, ',') != NULL ||  strchr(p_ctqbuf, ';') != NULL) )
       {

           if( strchr(p_ctqbuf, ',') && strchr(p_ctqbuf, ';'))  //if both a comma and semicolon were found, then
            {                                                                 //there is an error in the CREATE TABLE query file
               fprintf(stderr, "\nError in your CREATE TABLE query file\n");
               exit(1);
            }
       
            //if the column can contain a NULL value then set
            //column.null to 0
           column.null = 0;
           null_done = 1;
       }




     if( strstr(ucase, "NOT")) {
        
        if( (p_ctqbuf = skipcomment(fp)) != NULL) {
                 strcpy(ucase, p_ctqbuf);

                 //make the ucase buffer upper case
                 for(i = 0; i < MAX; i++) {
                 ucase[i] = toupper(ucase[i]);
                 }


                 //now check to see if the next word is "NULL"
                 if( strstr(ucase, "NULL")) {
                    column.null = 1;
                    null_done = 1;

                 }

        }


  }





/*=============================================================================*/




   //if it wasn't any of the above,or a comma then it must be the column name
    if( name_done == 0)//(type_done == 0) && (null_done == 0))
    {

           //check for reserved words
          if( chkres(p_ctqbuf) == 1)
          {
             fprintf(stderr, "\nERROR getcolumn.c: %s is a reserverd word.\n", p_ctqbuf);
             exit(1);
          }


           //just so the program doesnt get told that '(' is the column name
           if( strchr(p_ctqbuf, '(') == NULL)
             {
               sprintf(column.name, "%s", p_ctqbuf);
               name_done = 1;
             }

     }
     


         if(strchr(p_ctqbuf,';') )
            {
                 if(null_done == 0)  //make sure null_done gets set to 1 so the last column doesnt get skipped
                 { null_done = 1; column.null =0; }
                 
              
                //return 0;
             }



    if( name_done != 0 && type_done != 0 && null_done != 0)
    {

     

      //  else{ return p_column; }

        return p_column;
        
      }





    

    }   //end of while loop


  return 0;

}
/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm                                          
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|   
|   Foundation, Inc., 
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|  
|
|                   gettable.c REV 3 for SQL Query Generator
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|  
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/
#include "querygen.h"

char *gettable( FILE *fp)
{



      char *p_tablename;
      static char tablename[MAX];       //return pointer to array
      char user_input[MAX];              //what the user types in for tablename, use this instead of tablename in case
                                                    //the user just presses enter for the default table.
      

      char lp_buf[MAX];             //Left parenthesis buffer, used to find the first '(' after the table name
      int i;                                 //for counting



rewind(fp);  //rewind so gettable() can return a list of tables to the user every time they create a query
                 //so they can create queries for different tables.
      
printf("\n\nTable name\n\n");



while( (p_tablename = skipcomment(fp)) != NULL)
{

 

       if( strstr(p_tablename, "CREATE") != NULL )
       {


             //get the next thing from the file
             p_tablename = skipcomment(fp);

             if( strcmp(p_tablename,"TABLE") == 0 )  {


                  if( (p_tablename = skipcomment(fp)) != NULL) {

                  //before returning the table name,
                 //we need to get past the '('
                     strcpy(lp_buf, p_tablename);

                     //first see if '(' is right after the table name
                     //if it is, just replace it with NULL
                     for(i = 0; i < MAX; i++)
                     {


                          if(lp_buf[i] == '(')
                          {
                              lp_buf[i] = '\0';
                              break;
                          }

                      }

                      //if i is MAX, then the '(' was not found in the loop above
                    if(i == MAX) {

                         //so now we need to get '(' from the file
                         //and to do so, we need to use an infinite loop
                         //and check each character
                         for(;;) {

                                i = fgetc(fp);

                                if(i == '(')
                                break;

                                else

                                if(i == EOF)
                                {
                                     fprintf(stderr, "There is an error in your CREATE TABLE query.\n");
                                     exit(1);
                                }

                                i++;

                           } //end of for(;;)

                    } //end of if(i ==MAX)

                    //now we have the table name
                    //but before returning it, check for reseverd words
                       if( chkres(p_tablename) == 0)
                        printf("%s\n", p_tablename); //print the table name to the screen
                       

                      else
                       {
                         fprintf(stderr, "\nERROR: %s is a reserved word.\n", p_tablename);
                          exit(1);
                       }


                   }

           }  // end of   if( strcmp(p_tablename,"TABLE") == 0 )
        }     // end of   if( strcmp(p_tablename, "CREATE"))


        
  }//end of while loop

  printf("\nType in the name of the table you want to make a query for [%s] ", tablename);
  
  fgets(user_input, MAX, stdin); //this is where the user types in the table they want to make a query for
  user_input[strlen(user_input)-1] = '\0'; //put the null at the end

   //if the user does not press enter and types in the table name,
   //then copy user_input to tablename before it is returned
   if(user_input[0] != '\0')
     strcpy(tablename, user_input);

      
  

   return tablename;  

   
}
/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|
|   Foundation, Inc.,
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|
|
|                   insert_query.c REV 6 for SQL Query Generator
|
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/
 #include "querygen.h"




void insert_query( void ) {

      

  extern char out[MAX];
  extern char ctqfile[MAX];		                        // this is the CREATE TABLE query file
  char ins_string[BIGBUF] = "INSERT INTO ";
  char val_string[BIGBUF] = "VALUES(";
  char *tablename;
  char *p_ctqbuf;
  int user_done;                                     //ask user if they are done(this will be either Y or N)
  int loop_done = 0;                                      //used to controll while loop
  int stringpos;                                       //position of string
  int startpos = 0;                                   //this will hold the starting point for stringpos
  int i = 0;                                              //for counting
  extern int appendfile;                           //option for appending output file
  extern int printstdout;                           //option to print the output to stdout
  extern int useoutputfile;                       //see comment about this in querygen.h and main.c
  sqltable *column;                                 //the pointer to the struct


  // these are the user input variables
  int           input_smallint;
  long        input_integer;
  float        input_floatingpoint;
  char        inputstring[MAX];
  char        *p_inputstring = inputstring;
  extern char *p_addslash;  //will point to output_buffer from addslash()
  char        inputbuffer[MAX];



    
  // file descriptors for this module
  FILE *fpctq, *fpout;

   

  //First open "ctq" in read only mode and open "out" for writing

  if( (fpctq = fopen(ctqfile, "r")) == NULL) {
    fprintf(stderr, "\nCouldn't open file %s\n", ctqfile);
    exit(1);
    }


  
if(useoutputfile == 1)
{
        
  if(appendfile == 1)
  {

       if( (fpout = fopen(out, "a")) == NULL)
       {
         fprintf(stderr, "\nCouldn't create file %s\n", out);
         exit(2);
       }

   }


   else
   {

         if( (fpout = fopen(out, "w")) == NULL)
         {
             fprintf(stderr, "\nCouldn't create file %s\n", out);
             exit(2);
          }

   }



   fprintf(fpout, "/* This file made by SQL Query Generator %.1f*/\n", PROGRAM_VERSION);
   fprintf(fpout, "/* go to http://change.to/opensource for the latest updates */\n\n\n");

}



             //we will always have to get past the first '('
            for(stringpos = 0; stringpos < BIGBUF; stringpos++)
            {
                     if(ins_string[stringpos] == '(')
                     {
                          startpos = stringpos;
                          break;
                     }

            }



 while(loop_done != 1)
 {

          strcpy(ins_string, "INSERT INTO "); //reset ins_string before using strcat()
          strcpy(val_string, "VALUES(");
       //the code below which is indented does the following:
       // 1. Asks the user what table they want to make a query for
       // 2. rewinds the fpctq file so it can be advanced to the correct spot to read the columns for the table the user selected.
       // 3. the while loop advances the fpctq file to the correct spot        
        if( (tablename = gettable(fpctq)) == 0)
        exit(1);
          
         //add the tablename and ( to ins_string
         strcat(ins_string, tablename);
         strcat(ins_string, "(");


         rewind(fpctq);
         //first get to the part of the fpctq file that creates
         //the columns for the table that the user wants
        //to make a query for

        while ( (p_ctqbuf = skipcomment(fpctq)) != NULL )
        {
            if(strcmp(p_ctqbuf, tablename) == 0)
            break;

            //TODO: should do error checking here, check for EOF.
        }
     


 //when the loop starts, start a sub-loop that will get the column names and ask the user
 //for input.  These will be written to the output file according to the data type of the column
  while(   ((column = getcolumn(fpctq)) != 0)   )  
  {
           strcat(ins_string, column->name);
           strcat(ins_string, ", ");

//make this NULL so when the program checks to see if the user
//entered something for a column that is NOT NULL it will only
//let them continue until something is entered
inputstring[0] = '\0';

        printf("\nEnter value for %s (datatype %s) ", column->name, column->type);


       if(column->null == 1)
       {
            while(inputstring[0] == '\0')
            {

              fgets(inputstring, BIGBUF, stdin); //this is where the user types the value to put in the column
              inputstring[strlen(inputstring)-1] = '\0';

            }

           
            
        } //end if(column->null == 1)

       else //just do it once if the column can be null
       {
           fgets(inputstring, BIGBUF, stdin);
           inputstring[strlen(inputstring)-1] = '\0';
           
       }


            //add backslashes before single quotes
            p_addslash = addslash(p_inputstring);
            strcpy(inputstring, p_addslash);


       
          //now check the data type and use appropriate method of getting user input
          //after getting input from user, put the data into the val_string

          if( strcmp(column->type,"SMALLINT") == 0 )
          {


             input_smallint = atoi(inputstring);
                   sprintf(inputbuffer, "%d", input_smallint);
                   strcat(val_string, inputbuffer);
                   strcat(val_string, ", ");
          }



           else if( strcmp(column->type,"TINYINT") == 0 )
          {

            
                   sprintf(inputbuffer, "%s", inputstring);
                   strcat(val_string, inputbuffer);
                   strcat(val_string, ", ");

          }



          else if( strcmp(column->type,"INTEGER") == 0 || strcmp(column->type, "REAL") == 0)
          {


             input_integer = atoi(inputstring);
                    sprintf(inputbuffer, "%ld", input_integer);
                    strcat(val_string, inputbuffer);
                    strcat(val_string, ", ");
          }



          else if( strcmp(column->type,"FLOAT") == 0 )
          {


             input_floatingpoint = atof(inputstring);
                   sprintf(inputbuffer, "%f", input_floatingpoint);
                   strcat(val_string, inputbuffer);
                   strcat(val_string, ", ");
           }



          else if( strcmp(column->type,"CHAR") == 0 )
          {
                 strcat(val_string, "\'");
                 strcat(val_string, inputstring);
                 strcat(val_string, "\'");
                 strcat(val_string, ", ");
            }



           else
           {
             printf("\nData type %s not supported\n", column->type);
             exit(1);
           }


} //end of loop that fills up the val_string

     /* now we have to take off the last comma and replace with ')'
        In order to do this eficiently, we will have to find the NULL character by searching
        from the beginning to the end of the string.  Then start searching backwards from the
        NULL character for a comma(it should be right before the NULL character).  After finding
        the NULL character, replace it with a  ")"  */


     for(i = 0; i < BIGBUF; i++)
     {

               if( ins_string[i] == '\0')
               {
                    ins_string[i -= 2] = ')';
                    break;
               }

     }
  


                   //before placing val_string into the file, change the last comma to a ")"
                  for(i = 0; i < BIGBUF; i++)
                  {
                        if( val_string[i] == '\0')
                        {
                             val_string[i -= 2] = ')';
                             break;
                        }

                    }

 
            if(printstdout == 1)
            {
              printf("\nHere is your query:\n\n\n");
              printf("%s\n", ins_string);
              printf("%s;\n\n", val_string);
            }
      
           if(useoutputfile == 1)
           { 
              //ok, now put the INSERT INTO and VALUES strings in the file
              fprintf(fpout, "%s\n", ins_string);
              fprintf(fpout, "%s;\n\n", val_string);
           }


           printf("\n\nAre you done entering data?(N/y)");


            user_done = toupper(getc(stdin));



              switch (user_done) {

                 case 'Y' :

                     printf("\nThank you for using SQL Query Generator %.1f.\n", PROGRAM_VERSION);

                      //close files before exiting
                      if(useoutputfile == 1) fclose(fpout);  //only close the file if it was opened
                      fclose(fpctq);

                      loop_done = 1;
                      break;


                 case 'N' :
                       loop_done = 0;
                            getc(stdin); //eat newline here so user wont have to press enter twice for default option                           
                       break;



                 default :
                        loop_done = 0;                                                      
                            break;

                } //end of switch




     } //end of while loop


exit(0);


} //end of insert_query


/*============================================================================
|   Copyright (C) 2001-2002  Jonathan Harm
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|
|   Foundation, Inc.,
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|
|
|                   main.c  REV 6  for SQL Query Generator
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "querygen.h"


void show_usage(char *progname );

int main(int argc, char *argv[])
{



    extern char out[MAX];
    extern char ctqfile[MAX];
    char option, call_function;
    char longoption[MAX];
    int i, optioncount = 0;
    int longoption_ch;
    extern int appendfile; //the option for appending a file
    extern int printstdout;
    extern int useoutputfile; //1: use the output file | 0: no output file used (only --print-stdout)

     //this only gets set to 0 when argc == 4
     useoutputfile = 1;



   if( (argc > 6) || (argc < 3) )
   {
     show_usage( argv[0]);
   }



for(i = 1; i < argc; i++)
{

   optioncount = 0;

   //now check to see if the option starts with the '-'
   if(argv[i][0] == '-')
       while( isalpha(argv[i][++optioncount]) != 0)
       {
            //argv[1][1] contains the letter after the '-'
            option = argv[i][optioncount];

             //the option switch
             switch(option)
             {

                 case 'i':
                   call_function = argv[i][optioncount];
                   break;

                 case 'u':
                   call_function = argv[i][optioncount];
                   break;

                  case 'd':
                    call_function = argv[i][optioncount];
                    break;

                  case 'a':
                    appendfile = 1;  //option for appending the output file
                    break;

                   case 'p':
                     printstdout = 1;
                     break;

                   default:

                     show_usage( argv[0] );
                     break;

             }

         } //end while(isspace(argv[i][++optioncount]) != 0)


/////////////////////////////////////////   L O N G    O P T I O N S   ///////////////////////////////////////////////////////////////////

   //  long options
  if(argv[i][0] == '-' && argv[i][1] == '-')
  {


       optioncount = 1; // long options use two dashes, so setting this to 1 will skip the
                              //first two dashes when ++optioncount is done in the while loop below


       longoption_ch = 0; //make sure to start at the beginning of the array


        //when checking ispunct() dont use ++optioncount because it is already incremented
       while(  (isalpha(argv[i][++optioncount]) != 0 || ispunct(argv[i][optioncount] != 0) )  || argv[i][optioncount] != '\0' )
       {

             longoption[longoption_ch] = argv[i][optioncount];
             longoption_ch++;
 
       }

       //add NULL character to end of longoption
       longoption[longoption_ch] = '\0';


       //cant use switch for arrays, so use a bunch of IF statements
       if(strcmp(longoption, "print-stdout") == 0)
          printstdout = 1;

       else if(strcmp(longoption, "append-file") == 0)
        appendfile =1;
          
       else if(strcmp(longoption, "insert-query") == 0)
        call_function = 'i';  

       else if(strcmp(longoption, "delete-query") == 0)
        call_function = 'd';

       else if(strcmp(longoption, "update-query") == 0)
        call_function = 'u';

       
    

       else { printf("FLAG 2\n"); show_usage(argv[0]); exit(1); } 

  }

    
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

   } //end of for loop



//do some error checking to make sure users are using the options correclty
   
   //get input and output filenames / if user chose --print-stdout then dont look for an output filename
   if(printstdout == 1)
   {

               if(argc <= 4) //argc could be 3 if user uses "-ip" as option with no output file  
               {
                 useoutputfile = 0;       
                 sprintf(ctqfile, "%s", argv[--argc]);
               }

               if(argc == 5 || argc == 6)   //if user decides to do append the file then argc would be 6
               {
                 sprintf(out, "%s", argv[--argc]);
                 sprintf(ctqfile, "%s", argv[--argc]);
               }              

    }

    

    else //if user didn't select --print-stdout option
    {
        sprintf(out, "%s", argv[--argc]);
        sprintf(ctqfile, "%s", argv[--argc]);
    }


   
             //switch to call the functions
             switch(call_function)
             {

                 case 'i':
                 
                    insert_query();
                   break;

                 case 'u':
                    update_query();
                    break;

                 case 'd':
                    delete_query();
                    break;

                  default:
                     show_usage( argv[0] );
                     break;

               }



  return 0;
}


//when calling this function, just pass argv[0] because that is the program name
void show_usage(char *progname)
{

          printf("\n\nSQL Query Generator %.1f\t by Jonathan Harm\n", PROGRAM_VERSION);
          printf("\nusage: %s {-i -d -u} [OPTIONS] [CREATE TABLE FILE] [OUTPUT FILE]", progname);
          
          printf("\n\n\tOperation mode\t\t\tDescription\n");
          printf("\n\t-i, --insert-query\t\tmake an INSERT INTO query");
          printf("\n\t-u, --update-query\t\tmake an UPDATE query");
          printf("\n\t-d, --delete-query\t\tmake a DELETE query");
        
          printf("\n\n\n\n\tOption\t\t\t\tDescription\n");
          printf("\n\t-a, --append-file\t\tappend the output file");
          printf("\n\t-p, --print-stdout\t\tprint the output to the screen\n\n");
          
          exit(1);
}

/*============================================================================
|   Copyright (C) 2001  Jonathan Harm
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|
|   Foundation, Inc.,
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|
|
|                   skipcomment.c REV 7 for SQL Query Generator
|
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/
#include "querygen.h"

char *skipcomment(FILE *fp)
{



     int count = 0, ch;
     static char buffer[MAX];





 while(count < MAX)
    {

    ch = fgetc(fp);

    //check for EOF and return NULL if it is found
    if( ch == EOF)
    {
       return NULL;
    }


    //use switch to look for comments
    switch (ch)
       {

       case '/':


         if( (ch = fgetc(fp)) == '*')
            {

            //now go to end of comment
            //or quit if EOF is found
            while(1)
                   {

                      ch = fgetc(fp);


                       //look for * then /
                       if( (ch == '*'))
                           {
                             if( (ch = fgetc(fp)) == '/')
                             break;
                           }


                       if(ch == EOF)
                            {
                             fprintf(stderr, "Comment doesn't have an end.\n");
                             exit(1);
                            }


                   }


         }



       break;


       case '-':
         if( (ch = fgetc(fp)) == '-')
              {

                        //if it is an Oracle syle comment, then
                        //just use fgetc until \n or \r is found
                       while( ch != '\r')
                       {

                              ch = fgetc(fp);
                       }

               }
        //might need to unget char here

       break;



       //before putting ch into the buffer, do some checking
       //for spaces, parenthesis, and other punctuation
       default:

          //store alphanumeric and puncuation characters into buffer
          if( (isalnum(ch) != 0 || ispunct(ch) != 0))
              {

                  //store ch to buffer then increment count
                  buffer[count] = ch;

                  //increment count
                  count++;


                      //now see if space is the next character

                      ch = fgetc(fp);
                      if( isspace(ch) != 0)
                      {

                           buffer[count] = '\0';
                           return buffer;
                      }

                      else
                      {

                           fseek(fp, -1, SEEK_CUR);

                       }



              }

       break;



    } //end of switch



} //end of while loop


return NULL;

} //end of function
/*============================================================================
|   Copyright (C) 2001-2003  Jonathan Harm
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   update_query.c REV 7 or SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/ 


#include "querygen.h"


void update_query( void )
{



  extern char out[MAX];
  extern char ctqfile[MAX];		                    // this is the CREATE TABLE query file
  char update_query[BIGBUF];                 //this is what is written to the file
  char unique_query[BIGBUF];                 //part of the query that contains "WHERE x = y"
  char unique_info[MAX];                         //information unique to the row(s) being updated
  char *p_unique_info = unique_info;
  char input_string[BIGBUF];                   //for the user to input the data to update the column
  char *p_input_string = input_string;
  extern char *p_addslash;                      //this is defined in querygen.h
  char update_column[MAX];                   //the column to be updated
  char unique_column[MAX];                   //column containing unique info for updating only certian row(s)
  char *tablename, *p_ctqbuf;
  int user_done;                                      //ask user if they are done(this will be either Y or N)
  int loop_done;                                      //used to control when the while loop ends
  extern int appendfile;                            //option for appending output file
  extern int printstdout;                           //option to print output to stdout
  extern int useoutputfile;                          //see querygen.h
  char col_or_row;                                   //when asking user "[C]olumn or [R]ow"
  sqltable *column;                                  //used for finding the datatype of a column

 // used for converting a string to a numerical
 //datatype when creating the unique_query string
  char        input_tinyint;
  int           input_smallint;
  long        input_integer;
  float        input_floatingpoint;




  FILE *fpctq, *fpout;




  //First open "ctq" in read only mode and open "out" for writing

  if( (fpctq = fopen(ctqfile, "r")) == NULL) {
    fprintf(stderr, "\nCouldn't open file %s\n", ctqfile);
    exit(1);
    }


if(useoutputfile == 1)
{   

     if(appendfile == 1)
     {

         if( (fpout = fopen(out, "a")) == NULL)
         {
           fprintf(stderr, "\nCouldn't create file %s\n", out);
           exit(2);
          }

     }

     else
     {

         if( (fpout = fopen(out, "w")) == NULL)
         {
             fprintf(stderr, "\nCouldn't create file %s\n", out);
             exit(2);
          }

     }




  fprintf(fpout, "\n/* This file made by SQL Query Generator %.1f*/\n", PROGRAM_VERSION);
  fprintf(fpout, "/* go to http://change.to/opensource for the latest updates */\n\n\n");

} //end of "if(useoutputfile == 1)"




//in this loop, ask what column to update
//and weather to update the whole column
  while( loop_done != 1 )
  {

      input_string[0] = '\0'; //set to null for error checking


       if( (tablename = gettable(fpctq)) == 0)
      exit(1);



      printf("\nWhat column do you want to update? ");
      fgets(update_column, MAX, stdin);  update_column[strlen(update_column)-1] = '\0';
      //remove newline char and replace it with NULL

     //Advance to the right spot in fpctq
                         rewind(fpctq);
                   //first get to the part of the fpctq file that creates
                   //the columns for the table that the user wants
                  //to make a query for

                 while ( (p_ctqbuf = skipcomment(fpctq)) != NULL )
                 {
                      if(strcmp(p_ctqbuf, tablename) == 0)
                      break;

                     //TODO: should do error checking here, check for EOF.
                  }
     

      //need to getcolumn for the column->null error checking
      while(1)
       {
               column = getcolumn(fpctq);
               
               if( strcmp(update_column, column->name) == 0)
               break;

               if( column == 0)
               { fprintf(stderr, "column \"%s\" is not in the table \"%s\"\n", update_column, tablename); exit(1); }
               
       }



      /*ask user if they want to update the entire
        column or just 1 row */

      printf("\nWould you like to update the entire [C]olumn or only specific [R]ow(s)? ");
        col_or_row = toupper(  fgetc(stdin) );
        getc(stdin); //eat newline character so fgets doesn't get it


      if( col_or_row == 'C')
      {


            //prompt user to input data, then write it to the output file
            printf("\nNow type in the information to update \"%s\": ", update_column);

            //do column->null error checking
            if(column->null == 1)
            {
                   while(input_string[0] == '\0')
                   {
                        fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0';
                   }
                   
            }

             else { fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0'; }

                        p_addslash = addslash(p_input_string);
                        strcpy(p_input_string, p_addslash);
             

                       //for now, just check to see if it is or isn't numerical
                        if( strcmp(column->type, "CHAR") == 0)
                         sprintf(update_query, "UPDATE %s\nSET %s = \'%s\'", tablename, update_column, input_string);


                        else
                         sprintf(update_query, "UPDATE %s\nSET %s = %s", tablename, update_column, input_string);


            if(printstdout ==1)
             printf("%s;", update_query);
                         
            else
            fprintf(fpout, "%s;", update_query);

       }


        else if(col_or_row == 'R')
        {

               //so the user only wants to update certain row(s).
               //TODO:  display list of columns for user (version 0.3 or later)
               //1. ask user what column  contains information unique to the row(s) they want to update
               //2. ask user what that information is


            //prompt user to input data, then write it to the update_query string
            printf("\nNow type in the information to update \"%s\": ", update_column);

            //do column->null error checking
            if(column->null == 1)
            {
                   while(input_string[0] == '\0')
                   {
                        fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0';
                   }
            }

             else { fgets(input_string, MAX, stdin);   input_string[strlen(input_string)-1] ='\0'; }

            p_addslash = addslash(p_input_string);
            strcpy(p_input_string, p_addslash);

            sprintf(update_query, "UPDATE %s\nSET %s = ", tablename, update_column);


            //1. ask user what column contains the unique info
            // Also use getcolumn() to get the datatype
            printf("\nWhat column contains the information unique to the row(s) you want to update? ");
            fgets(unique_column, MAX, stdin);  unique_column[strlen(unique_column)-1] = '\0';


            //2. ask user to type in the information unique to that row(s)
            printf("\nNow type in the information that is unique in that column: ");
            fgets(unique_info, MAX, stdin);   unique_info[strlen(unique_info)-1] = '\0';

            //3. add slashes to unique_info (if needed)
            p_addslash = (p_unique_info);
            strcpy(p_unique_info, p_addslash);
            


                   rewind(fpctq);
                   //first get to the part of the fpctq file that creates
                   //the columns for the table that the user wants
                  //to make a query for

                 while ( (p_ctqbuf = skipcomment(fpctq)) != NULL )
                 {
                      if(strcmp(p_ctqbuf, tablename) == 0)
                      break;

                     //TODO: should do error checking here, check for EOF.
                  }


             //  |  get datatype of column so the program will
            //  \/ know if it needs to put qoutes around the input
     
            while( (column = getcolumn(fpctq)) != 0)
            {

                 //as soon as the column name is found check to see if it is numerical or string
                 //datatype so the program can put quotes around numerical data and leave
                 //qoutes off of strings
                 if( strcmp(column->name, unique_column) == 0)
                 {

                   //first take care of numerical datatypes

                     if( strcmp(column->type,"SMALLINT") == 0)
                      {
                        input_smallint = atoi(unique_info);
                        sprintf(unique_query, "WHERE %s = %d", unique_column, input_smallint);
                      }


                     else if( strcmp(column->type,"TINYINT") == 0)
                      {
                        input_tinyint = atoi(unique_info);
                        sprintf(unique_query,"WHERE %s = %d", unique_column, input_tinyint);
                      }


                     else if( strcmp(column->type,"FLOAT") == 0)
                      {
                        input_floatingpoint = atoi(unique_info);
                        sprintf(unique_query,"WHERE %s = %f", unique_column, input_floatingpoint);
                      }


                     else if( strcmp(column->type,"INTEGER") == 0 || strcmp(column->type,"REAL") == 0)
                      {
                        input_integer = atoi(unique_info);
                        sprintf(unique_query,"WHERE %s = %ld", unique_column, input_integer);


                     }


          /*
         //               Done with the numerical data.  Everything below this line
         //               will only deal with character type data.
         //=====================================================*/


                      else if( strcmp(column->type,"CHAR") == 0)
                       {
                         sprintf(unique_query,"WHERE %s = \'%s\'", unique_column, unique_info);


                       }


                    // if the datatype of the column the user entered data for
                    // was not in the above if statement, then that datatype is
                    // not supported
                    else
                     {
                       fprintf(stderr, "Datatype %s not supported\n", column->type);
                     }


                 }



         /*==================================================================*/
                 /*= deal with qoutes that may or may not need to be around input_string==*/

                   if( strcmp(column->name, update_column) == 0)
                   {


                     if( strcmp(column->type,"SMALLINT") == 0)
                      {
                        strcat(update_query, input_string);
                      }


                     else if( strcmp(column->type,"TINYINT") == 0)
                      {
                        strcat(update_query, input_string);
                      }


                     else if( strcmp(column->type,"FLOAT") == 0)
                      {
                         strcat(update_query, input_string);
                      }


                     else if( strcmp(column->type,"INTEGER") == 0 || strcmp(column->type,"REAL") == 0)
                      {
                         strcat(update_query, input_string);
                      }


          /*
         //               Done with the numerical data.  Everything below this line
         //               will only deal with character type data.
         //=====================================================*/


                      else if( strcmp(column->type,"CHAR") == 0)
                       {
                         strcat(update_query, "\'");
                         strcat(update_query, input_string);
                         strcat(update_query, "\'");
                       }


                    // if the datatype of the column the user entered data for
                    // was not in the above if statement, then that datatype is
                    // not supported
                    else
                     {
                       fprintf(stderr, "Datatype %s not supported\n", column->type);
                     }

                }


            } //end of while loop

            if(printstdout == 1)
             printf("%s\n%s;\n\n", update_query, unique_query);


            else 
            //and finally write it to the file
            fprintf(fpout, "%s\n%s;\n\n", update_query, unique_query);

         } //end of "else if(col_or_row == 'R')"



         else
         {
            fprintf(stderr, "You did not enter C or R\n");
            exit(1);
         }







     printf("\n\nAre you done entering data?(N/y)");

       user_done = toupper(getc(stdin));


       switch (user_done) {

                 case 'Y' :

                     printf("\nThank you for using SQL Query Generator %.1f.\n", PROGRAM_VERSION);

                      //close files before exiting
                      if(useoutputfile == 1) fclose(fpout);
                      fclose(fpctq);
                      loop_done = 1;

                      break;


                 case 'N' :
                       loop_done = 0;
                       memset(update_query, ' ', BIGBUF);
                       memset(unique_query, ' ', BIGBUF);

                       getc(stdin); //eat newline

                       break;


                 default :
                        loop_done = 0;
                        memset(update_query, ' ', BIGBUF);
                        memset(unique_query, ' ', BIGBUF);

                         break;

                } //end of switch



  } //end while loop



exit(0);

}

